## org.jfree.report
Interface DataRow

All Superinterfaces:
  DataSet

All Known Implementing Classes:
  ExpressionDataRow, FastGlobalView, GlobalView, ImportedVariablesDataRow, ParameterDataRow, ReportDataRow, StaticDataRow

    public interface DataRow

extends DataSet

This is the base interface for all data access collectors. A data-row adds a certain order to the elements in the dataset. It also allows statefull comparisions and data attributes using DataFlags.

The data-row is an internal concept of JFreeReport. The report engine will be responsible for creating and maintaining these implementations. Authors of functions and expressions usually dont have to care where a datarow comes from or at which particular instance they are looking right now.

Note: Do not attempt to cache the datarow outside the core engine. This can have funny sideeffects and might trigger the end of the world.

Author:
  Thomas Morgner

Method Summary
`java.lang.Object` `get(int col)` Returns the value of the expression or column in the tablemodel using the given column number as index.
`java.lang.Object` `get(java.lang.String col)` Returns the value of the function, expression or column using its specific name.
`int` `getColumnCount()` Returns the number of columns, expressions and functions and marked ReportProperties in the report.
`java.lang.String` `getColumnName(int col)` Returns the name of the column, expression or function.
`DataFlags` `getFlags(int col)` Queries lowlevel meta-data for the current value of the specified column.
`DataFlags` `getFlags(java.lang.String col)` Queries lowlevel meta-data for the current value of the specified column.

Method Detail

### get

    java.lang.Object get(int col)
                         throws DataSourceException

  Returns the value of the expression or column in the tablemodel using the given column number as index. For functions and expressions, the `getValue()` method is called and for columns from the tablemodel the tablemodel method `getValueAt(row, column)` gets called.

  Specified by:
    `get` in interface `DataSet`
  Parameters:
    `col` - the item index.
  Returns:
    the value.
  Throws:
    `java.lang.IllegalStateException` - if the datarow detected a deadlock.
    `DataSourceException` - if an error occured.

### get

    java.lang.Object get(java.lang.String col)
                         throws DataSourceException

  Returns the value of the function, expression or column using its specific name. The given name is translated into a valid column number and the the column is queried. For functions and expressions, the `getValue()` method is called and for columns from the tablemodel the tablemodel method `getValueAt(row, column)` gets called.

  Parameters:
    `col` - the item index.
  Returns:
    the value.
  Throws:
    `java.lang.IllegalStateException` - if the datarow detected a deadlock.
    `DataSourceException` - if an error occured.

### getColumnName

    java.lang.String getColumnName(int col)
                                   throws DataSourceException

  Returns the name of the column, expression or function. For columns from the tablemodel, the tablemodels `getColumnName` method is called. For functions, expressions and report properties the assigned name is returned.

  Specified by:
    `getColumnName` in interface `DataSet`
  Parameters:
    `col` - the item index.
  Returns:
    the name.
  Throws:
    `DataSourceException` - if an error occured.

### getColumnCount

    int getColumnCount()
                       throws DataSourceException

  Returns the number of columns, expressions and functions and marked ReportProperties in the report.

  Specified by:
    `getColumnCount` in interface `DataSet`
  Returns:
    the item count.
  Throws:
    `DataSourceException` - if an error occured.

### getFlags

    DataFlags getFlags(java.lang.String col)
                       throws DataSourceException

  Queries lowlevel meta-data for the current value of the specified column.

  Parameters:
    `col` - the colum for which to query the meta-data flags
  Returns:
    the dataflag collection for the value in the named column
  Throws:
    `DataSourceException` - if an error occured.

### getFlags

    DataFlags getFlags(int col)
                       throws DataSourceException

  Queries lowlevel meta-data for the current value of the specified column.

  Parameters:
    `col` - the colum for which to query the meta-data flags
  Returns:
    the dataflag collection for the value in the specified column
  Throws:
    `DataSourceException` - if an error occured.